#include <Audio.h>
#include <Wire.h>
#include <SPI.h>
#include <SD.h>
#include <SerialFlash.h>

// GUItool: begin automatically generated code
AudioSynthWaveformSine   sine1;          //xy=133,225
AudioSynthNoisePink      pink1;          //xy=133,267
AudioSynthWaveform       waveform1;      //xy=147,167
AudioFilterStateVariable filter1;        //xy=288,405
AudioMixer4              mixer1;         //xy=297,228
AudioEffectDelay         delay1;         //xy=464,553
AudioMixer4              mixer2;         //xy=465,431
AudioEffectEnvelope      envelope1;      //xy=498,230
AudioOutputI2S           i2s1;           //xy=687,432
AudioConnection          patchCord1(sine1, 0, mixer1, 1);
AudioConnection          patchCord2(pink1, 0, mixer1, 2);
AudioConnection          patchCord3(waveform1, 0, mixer1, 0);
AudioConnection          patchCord4(filter1, 0, mixer2, 0);
AudioConnection          patchCord5(mixer1, envelope1);
AudioConnection          patchCord6(delay1, 0, mixer2, 3);
AudioConnection          patchCord7(mixer2, delay1);
AudioConnection          patchCord8(mixer2, 0, i2s1, 0);
AudioConnection          patchCord10(mixer2, 0, i2s1, 1);
AudioConnection          patchCord9(envelope1, 0, filter1, 0);
AudioControlSGTL5000     sgtl5000_1;     //xy=139,53
// GUItool: end automatically generated code





int led_pin1 = 3;    // the number of the first LED pin
int ledState1 = LOW;             // ledState used to set the first LED
long previousMillis1 = 0;        // will store last time LED 1 was updated
long rate1;           // first led rate

int led_pin2 = 4;    // the number of the first LED pin
int ledState2 = LOW;             // ledState used to set the first LED
long previousMillis2 = 0;        // will store last time LED 1 was updated
long rate2;           // first led rate

long currentMillis;

int pot1_value;
int pot2_value;

int button_pin = 5;
int button_state;
int prev_button_state;

int cutoff;

void setup() {
  Serial.begin(9600);

  //required to setup sudio
  AudioMemory(200); //255 is max
  sgtl5000_1.enable();
  sgtl5000_1.volume(0.5);

  pinMode(led_pin1, OUTPUT);
  pinMode(led_pin2, OUTPUT);

  pinMode(button_pin, INPUT_PULLUP);

  waveform1.begin(1, 440, WAVEFORM_SAWTOOTH);
  sine1.amplitude(1);

  mixer1.gain(0, .8);
  mixer1.gain(1, 0);
  mixer1.gain(2, 0);

  mixer2.gain(0, .6);
  mixer2.gain(3, 0);

  delay1.delay(0, 200);

  // envelope1.attack(150);  // time in milliseconds
  envelope1.release(150);  // time in milliseconds
  envelope1.noteOn();

  filter1.resonance(.7);  //under .7 is negative, .7 is no resonance, 5 is max

}

void loop()
{

  // read the potentiometers
  pot1_value = analogRead(A1); // analogRead will return a value from 0 to 1023
  pot2_value = analogRead(A2);

  rate1 = pot1_value;
  waveform1.frequency(rate1);
  sine1.frequency(rate1);

  cutoff = map(pot2_value, 0, 1023, 0, 14000);
  filter1.frequency(cutoff);

  analogWrite(led_pin1, pot2_value / 4); //analogwrite is 8bits by defualt 0-255 while analog read if 10b, 0-1023

  prev_button_state = button_state; // remember where the button was at las loop
  button_state = digitalRead(button_pin); // is the button pin high or low

  digitalWrite(led_pin2, !button_state);

  if (button_state == 0 && prev_button_state == 1) {
    //the button has been pressed
    envelope1.noteOn();
  }

  if (button_state == 1 && prev_button_state == 0) {
    //the button has been released
    envelope1.noteOff();
  }



  currentMillis = millis();// only need to do this once

  if (currentMillis - previousMillis1 > 200) {
    previousMillis1 = currentMillis;

    Serial.print(" proc:");
    Serial.print(AudioProcessorUsageMax());
    Serial.print("  mem:");
    Serial.println(AudioMemoryUsageMax());
    Serial.print(" cutoff:");
    Serial.println(cutoff);
    Serial.println();

    AudioProcessorUsageMaxReset();
    AudioMemoryUsageMaxReset();
  }


}

